<script src="/lib/sc-musical-map.js"></script>

<dom-module id="sc-score-mobile">

    <template>
        <svg id="myscore"></svg>
        <iron-ajax auto url="{{positions}}" handle-as="json" on-response="handleResponse" debounce-duration="300"></iron-ajax>
    </template>

    <script>
        Polymer({

            is: 'sc-score-mobile',
            map: new scMusicalMap.MusicalMap(),

            properties: {
                bg: String,
                positions: String,
            },

            listeners: {
                'down': 'down',
                'track': 'track',
                'tap': 'tap'
            },

            attached: function () {
                var self = this;
                this.getScreenState();
                this.getAvailableSize();
                this.onOrientationChange();
                this.img = new Image();
                this.img.src = self.bg;
                this.img.addEventListener("load", function (event) {
                    event.preventDefault();
                    self.img.width = this.naturalWidth;
                    self.img.height = this.naturalHeight;
                    var size = self.getSize(self.img.height, self.img.width, self.height);
                    self.paper = new scScore.Score(size["width"], size["height"], this.naturalHeight);
                    self.paper.attachImg(this.src, "content");
                    self.ratio = self.paper.ratio
                });

                if (navigator.vendor == "Google Inc.") {
                    this.lim = 500
                    this.clicklim = 300
                }
                else {
                    this.lim = 2000000
                    this.clicklim = 150000
                }
            },

            down: function (event) {

                var target = this.getTarget(event);

                if (target == "image") {
                    this.start = event.timeStamp;
                    this.x = event.detail.x + this.parentElement.scrollLeft;
                    var y = event.detail.sourceEvent.offsetY ||  event.detail.y
                    this.paper.createGlab(this.x,y);
                    console.log(event.detail)
                }

                if (target == "rect") {
                    event.preventDefault();
                    this.paper.select(event.target.id);
                }

                if (target == "polyline") {
                    event.preventDefault();
                    this.paper.saveCurrentState(event.detail.x, event.detail.y);
                }

            },

            track: function (event) {

                var target = this.getTarget(event);

                if (target == "image") {
                    this.trackOnImage(event);
                }

                if (target == "rect") {
                    event.preventDefault();
                    this.trackOnRect(event);
                }

                if (target == "polyline") {
                    event.preventDefault();
                    this.trackOnPolyline(event);
                }

            },

            trackOnPolyline: function (event) {
                this.paper.resizeGlab(event.detail.x, event.detail.y, event.target.id);
            },

            trackOnImage: function (event) {
                if (event.detail.state == "start") {
                    this.duration = event.timeStamp - this.start;
                }
                if (this.duration > this.lim && this.orientation.matches) {
                    this.paper.drawGlab(event.detail.dx, event.detail.dy, this.x);
                }
                else {
                    try {
                        this.paper.removeGlab();
                    }
                    catch (e) {

                    }
                }
            },

            trackOnRect: function (event) {
                event.preventDefault();
                this.paper.moveGlab(event.detail.dx, event.detail.dy);
            },

            tap: function (event) {

                var target = this.getTarget(event);

                if (target == "image") {
                    this.tapOnImage(event);
                }

                if (target == "rect") {
                    this.tapOnRect(event);
                }

            },

            tapOnImage: function (event) {
                //pas de click jusqu'à présent
                if (!this.firsttap) {
                    this.firsttap = event.timeStamp
                    //pas de valeur à comparer
                    return true;
                }

                //sinon on regarde à quand remonte le dernier click
                if (event.timeStamp - this.firsttap < this.clicklim) {
                    this.manageFullScreen();
                    this.firsttap = 0;
                }
            },

            tapOnRect: function (event) {
                //pas de click jusqu'à présent
                if (!this.firsttap) {
                    this.firsttap = event.timeStamp
                    //pas de valeur à comparer
                    return true;
                }

                this.paper.select(event.target.id);

                if (event.timeStamp - this.firsttap < this.clicklim) {
                    var x = this.paper.getCurrentGlabX()
                    var w = this.paper.getCurrentGlabWidth()
                    var staff = this.paper.getStaffAt(this.paper.getCurrentGlabY())

                    this.fire('iron-signal', {
                        name: 'player-sample',
                        data: {
                            start: this.map.toMusicalOnset(x),
                            duration: this.map.toMusicalDuration(x, w),
                            channel: staff
                        }
                    })

                    this.firsttap = 0
                }
            },

            getScreenState: function () {
                if (document.webkitIsFullScreen) {
                    this.fullScreen = document.webkitIsFullScreen;
                }
                else if (document.mozFullScreenEnabled) {
                    this.fullScreen = document.mozFullScreen;
                }
                else {
                    this.fullScreen = document.fullScreen;
                }
            },

            getAvailableSize: function () {
                this.orientation = window.matchMedia("(orientation :landscape)")
                if (window.matchMedia("(orientation :portrait)").matches) {
                    this.height = screen.availWidth;
                }
                else {
                    this.height = window.innerHeight;
                }
                this.currentHeight = this.height
            },

            getSize: function (h, w, windowHeight) {
                var height = h;
                var width = w;
                if (height >= windowHeight) {
                    height = windowHeight;
                    width /= (h / height);
                }
                return { height, width };
            },

            handleResponse: function (data) {
                this.map.setPositions(data.detail.response.notes)
                this.paper.setStaff(data.detail.response);
            },

            onOrientationChange: function () {
                var self = this;
                this.orientation.addListener(function (m) {
                    m.preventDefault();
                    if (m.matches) {
                        self.height = window.innerHeight;
                    }
                    else {
                        self.height = window.innerWidth;
                    }
                    var size = self.getSize(self.img.height, self.img.width, self.height)
                    self.paper.resize(size["width"], size["height"], self.img.height);
                })
            },

            manageFullScreen: function () {
                if (this.fullScreen) {
                    this.exitFullScreen();
                    this.fullScreen = false;
                }
                else {
                    this.requestFullScreen();
                    this.fullScreen = true;
                }
                this.height = window.innerHeight;
                var size = this.getSize(this.img.height, this.img.width, this.height);
                this.paper.resize(size["width"], size["height"], this.img.height);
            },

            exitFullScreen: function () {
                if (document.webkitExitFullscreen) {
                    document.webkitExitFullscreen();
                }
                else if (document.mozCancelFullScreen) {
                    document.mozCancelFullScreen();
                }
                else {
                    document.exitFullscreen();
                }
            },

            requestFullScreen: function () {
                if (document.documentElement.webkitRequestFullscreen) {
                    document.documentElement.webkitRequestFullscreen();
                }
                else if (document.documentElement.mozRequestFullscreen) {
                    document.documentElement.mozRequestFullScreen();
                }
                else {
                    document.documentElement.requestFullscreen();
                }
            },

            getTarget: function (event) {
                return event.target.nodeName;
            }

        })
    </script>
</dom-module>
